from time import strptime, strftime, mktime
from datetime import datetime
from collections import OrderedDict
import re
import logging


def timeConvert(s):
    t = strptime(s, "%a, %Y-%m-%d %H:%M:%S")
    return strftime("%Y-%m-%d %H:%M:%S", t)


def calcDuration(startTime, endTime):
    strucTime = strptime(startTime, "%Y-%m-%d %H:%M:%S")
    t1 = datetime.fromtimestamp(mktime(strucTime))
    strucTime = strptime(endTime, "%Y-%m-%d %H:%M:%S")
    t2 = datetime.fromtimestamp(mktime(strucTime))
    duration = ((t2) - (t1))
    return str(duration)


class borg():
    def __init__(self):
        '''constructor'''

    columns = OrderedDict([
        ('bg_thisCompressedSize', ['bg_thisCompressedSize', 'varchar(512)']),
        ('bg_thisDedupSize', ['bg_this_DidupSize', 'varchar(512)']),
        ('bg_allOrigSize', ['bg_allOrigSize', 'varchar(512)']),
        ('bg_allCompressedSize', ['bg_allCompressedSize', 'varchar(512)']),
        ('bg_allDedupSize', ['bg_allDedupSize', 'varchar(512)'])
    ])

    def parse(self, backupOutput):
        entries = OrderedDict([])
        output = ''
        try:
            for line in backupOutput:
                output += line
                if '/pre'in line:
                    entries['precommand'] = line.split('- ')[1].rstrip('\n')
                if 'Time (start):' in line:
                    value = line.rstrip('\n')
                    value = re.sub('.*start\):\ *', '', value)
                    entries['startTime'] = timeConvert(value)
                if 'Time (end):' in line:
                    value = line.rstrip('\n')
                    value = re.sub('.*end\):\ *', '', value)
                    entries['endTime'] = timeConvert(value)
                if 'Duration:' in line:
                    entries['duration'] = line.rstrip('\n').strip('Duration: ')
                if 'This archive:' in line:
                    entries['backupSize'] = line.split()[2]
                    entries['bg_thisCompressedSize'] = line.split()[4]
                    entries['bg_thisDedupSize'] = line.split()[6]
                if 'All archives:' in line:
                    entries['bg_allOrigSize'] = line.split()[2]
                    entries['bg_allCompressedSize'] = line.split()[4]
                    entries['bg_allDedupSize'] = line.split()[6]
            entries['duration'] = calcDuration(entries['startTime'],
                                               entries['endTime'])
            entries['output'] = output
            entries['backupSuccess'] = 1
            return entries
        except KeyError:
            # on key error we assume the output was not as expected and the
            # backup went wrong
            logging.info("Could not parse the Output. Key error")
            entries['output'] = output
            entries['backupSuccess'] = 0
            return entries
        except:
            logging.info("Could not parse the Output. Unknown reason")
            entries['output'] = output
            entries['backupSuccess'] = 0
            return entries

    def getColumns(self):
        print self.columns

    def addColumns(self):
        print('not yet implemented')
