import MySQLdb

# we need them to create database
# and since dicts aren't sorted by order of entry
# it's easier to create it again
createTableStatement = """
CREATE TABLE IF NOT EXISTS `backups` (
`ID` int(11) NOT NULL,
  `timestamp` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `hostname` varchar(512) NOT NULL,
  `backup` varchar(512) NOT NULL,
  `backupSuccess` varchar(512) NOT NULL,
  `startTime` DATETIME DEFAULT NULL,
  `endTime` DATETIME DEFAULT NULL,
  `duration` TIME DEFAULT NULL,
  `precommand` varchar(512) DEFAULT NULL,
  `backupSize` varchar(512) DEFAULT NULL,
  `dp_newFileSize` varchar(512) DEFAULT NULL,
  `dp_sourceFiles` varchar(512) DEFAULT NULL,
  `dp_sourceSize` varchar(512) DEFAULT NULL,
  `dp_newFiles` varchar(512) DEFAULT NULL,
  `dp_deletedFiles` varchar(512) DEFAULT NULL,
  `dp_changedFiles` varchar(512) DEFAULT NULL,
  `dp_changedDeltaSize` varchar(512) DEFAULT NULL,
  `dp_deltaEntries` varchar(512) DEFAULT NULL,
  `dp_rawSize` varchar(512) DEFAULT NULL,
  `dp_destSize` varchar(512) DEFAULT NULL,
  `dp_errors` varchar(512) DEFAULT NULL,
  `bg_thisCompressedSize` varchar(512) DEFAULT NULL,
  `bg_thisDedupSize` varchar(512) DEFAULT NULL,
  `bg_allOrigSize` varchar(512) DEFAULT NULL,
  `bg_allCompressedSize` varchar(512) DEFAULT NULL,
  `bg_allDedupSize` varchar(512) DEFAULT NULL,
  `output` text NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
"""
alterTablePrim = """
ALTER TABLE `backups`
 ADD PRIMARY KEY (`ID`);
"""

alterTableAuto = """
ALTER TABLE `backups`
 MODIFY `ID` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=6;
"""


def createDB(dbHost, dbUser, dbPass, dbName, dbPort):
    db = MySQLdb.Connect(host=dbHost,
                         user=dbUser,
                         passwd=dbPass,
                         db=dbName,
                         port=dbPort)
    cursor = db.cursor()
    cursor.execute(createTableStatement)
    cursor.execute(alterTablePrim)
    cursor.execute(alterTableAuto)
    db.close()
